/* ctrace.c -- automatically extracted from lua.h (5.1) */

#include <stdio.h>

#include "ctrace.h"

lua_State* Lua_newstate (lua_Alloc f, void* ud,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_State* rc = (lua_newstate)(f,ud);
 printf("%s:%d [%s] lua_newstate f=%p ud=%p -> %p\n",
	_FILE,_LINE,_FUNC,f,ud,rc);
 return rc;
}

void Lua_close (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_close)(L);
 printf("%s:%d [%s] lua_close L=%p\n",
	_FILE,_LINE,_FUNC,L);
}

lua_State* Lua_newthread (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_State* rc = (lua_newthread)(L);
 printf("%s:%d [%s] lua_newthread L=%p -> %p\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}

lua_CFunction Lua_atpanic (lua_State* L, lua_CFunction panicf,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_CFunction rc = (lua_atpanic)(L,panicf);
 printf("%s:%d [%s] lua_atpanic L=%p panicf=%p -> %p\n",
	_FILE,_LINE,_FUNC,L,panicf,rc);
 return rc;
}

int Lua_gettop (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_gettop)(L);
 printf("%s:%d [%s] lua_gettop L=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}

void Lua_settop (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_settop)(L,idx);
 printf("%s:%d [%s] lua_settop L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_pushvalue (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushvalue)(L,idx);
 printf("%s:%d [%s] lua_pushvalue L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_remove (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_remove)(L,idx);
 printf("%s:%d [%s] lua_remove L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_insert (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_insert)(L,idx);
 printf("%s:%d [%s] lua_insert L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_replace (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_replace)(L,idx);
 printf("%s:%d [%s] lua_replace L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

int Lua_checkstack (lua_State* L, int sz,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_checkstack)(L,sz);
 printf("%s:%d [%s] lua_checkstack L=%p sz=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,sz,rc);
 return rc;
}

void Lua_xmove (lua_State* from, lua_State* to, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_xmove)(from,to,n);
 printf("%s:%d [%s] lua_xmove from=%p to=%p n=%d\n",
	_FILE,_LINE,_FUNC,from,to,n);
}

int Lua_isnumber (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_isnumber)(L,idx);
 printf("%s:%d [%s] lua_isnumber L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

int Lua_isstring (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_isstring)(L,idx);
 printf("%s:%d [%s] lua_isstring L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

int Lua_iscfunction (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_iscfunction)(L,idx);
 printf("%s:%d [%s] lua_iscfunction L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

int Lua_isuserdata (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_isuserdata)(L,idx);
 printf("%s:%d [%s] lua_isuserdata L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

int Lua_type (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_type)(L,idx);
 printf("%s:%d [%s] lua_type L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

const char* Lua_typename (lua_State* L, int tp,
	const char* _FILE, int _LINE, const char* _FUNC) {
 const char* rc = (lua_typename)(L,tp);
 printf("%s:%d [%s] lua_typename L=%p tp=%d -> \"%s\"\n",
	_FILE,_LINE,_FUNC,L,tp,rc);
 return rc;
}

int Lua_equal (lua_State* L, int idx1, int idx2,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_equal)(L,idx1,idx2);
 printf("%s:%d [%s] lua_equal L=%p idx1=%d idx2=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx1,idx2,rc);
 return rc;
}

int Lua_rawequal (lua_State* L, int idx1, int idx2,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_rawequal)(L,idx1,idx2);
 printf("%s:%d [%s] lua_rawequal L=%p idx1=%d idx2=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx1,idx2,rc);
 return rc;
}

int Lua_lessthan (lua_State* L, int idx1, int idx2,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_lessthan)(L,idx1,idx2);
 printf("%s:%d [%s] lua_lessthan L=%p idx1=%d idx2=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx1,idx2,rc);
 return rc;
}

lua_Number Lua_tonumber (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_Number rc = (lua_tonumber)(L,idx);
 printf("%s:%d [%s] lua_tonumber L=%p idx=%d -> %g\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

lua_Integer Lua_tointeger (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_Integer rc = (lua_tointeger)(L,idx);
 printf("%s:%d [%s] lua_tointeger L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

int Lua_toboolean (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_toboolean)(L,idx);
 printf("%s:%d [%s] lua_toboolean L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

const char* Lua_tolstring (lua_State* L, int idx, size_t* len,
	const char* _FILE, int _LINE, const char* _FUNC) {
 const char* rc = (lua_tolstring)(L,idx,len);
 printf("%s:%d [%s] lua_tolstring L=%p idx=%d len=%p -> \"%s\"\n",
	_FILE,_LINE,_FUNC,L,idx,len,rc);
 return rc;
}

size_t Lua_objlen (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 size_t rc = (lua_objlen)(L,idx);
 printf("%s:%d [%s] lua_objlen L=%p idx=%d -> %u\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

lua_CFunction Lua_tocfunction (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_CFunction rc = (lua_tocfunction)(L,idx);
 printf("%s:%d [%s] lua_tocfunction L=%p idx=%d -> %p\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

void* Lua_touserdata (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 void* rc = (lua_touserdata)(L,idx);
 printf("%s:%d [%s] lua_touserdata L=%p idx=%d -> %p\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

lua_State* Lua_tothread (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_State* rc = (lua_tothread)(L,idx);
 printf("%s:%d [%s] lua_tothread L=%p idx=%d -> %p\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

const void* Lua_topointer (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 const void* rc = (lua_topointer)(L,idx);
 printf("%s:%d [%s] lua_topointer L=%p idx=%d -> %p\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

void Lua_pushnil (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushnil)(L);
 printf("%s:%d [%s] lua_pushnil L=%p\n",
	_FILE,_LINE,_FUNC,L);
}

void Lua_pushnumber (lua_State* L, lua_Number n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushnumber)(L,n);
 printf("%s:%d [%s] lua_pushnumber L=%p n=%g\n",
	_FILE,_LINE,_FUNC,L,n);
}

void Lua_pushinteger (lua_State* L, lua_Integer n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushinteger)(L,n);
 printf("%s:%d [%s] lua_pushinteger L=%p n=%d\n",
	_FILE,_LINE,_FUNC,L,n);
}

void Lua_pushlstring (lua_State* L, const char* s, size_t l,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushlstring)(L,s,l);
 printf("%s:%d [%s] lua_pushlstring L=%p s=\"%s\" l=%u\n",
	_FILE,_LINE,_FUNC,L,s,l);
}

void Lua_pushstring (lua_State* L, const char* s,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushstring)(L,s);
 printf("%s:%d [%s] lua_pushstring L=%p s=\"%s\"\n",
	_FILE,_LINE,_FUNC,L,s);
}

void Lua_pushcclosure (lua_State* L, lua_CFunction fn, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushcclosure)(L,fn,n);
 printf("%s:%d [%s] lua_pushcclosure L=%p fn=%p n=%d\n",
	_FILE,_LINE,_FUNC,L,fn,n);
}

void Lua_pushboolean (lua_State* L, int b,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushboolean)(L,b);
 printf("%s:%d [%s] lua_pushboolean L=%p b=%d\n",
	_FILE,_LINE,_FUNC,L,b);
}

void Lua_pushlightuserdata (lua_State* L, void* p,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_pushlightuserdata)(L,p);
 printf("%s:%d [%s] lua_pushlightuserdata L=%p p=%p\n",
	_FILE,_LINE,_FUNC,L,p);
}

int Lua_pushthread (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_pushthread)(L);
 printf("%s:%d [%s] lua_pushthread L=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}

void Lua_gettable (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_gettable)(L,idx);
 printf("%s:%d [%s] lua_gettable L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_getfield (lua_State* L, int idx, const char* k,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_getfield)(L,idx,k);
 printf("%s:%d [%s] lua_getfield L=%p idx=%d k=\"%s\"\n",
	_FILE,_LINE,_FUNC,L,idx,k);
}

void Lua_rawget (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_rawget)(L,idx);
 printf("%s:%d [%s] lua_rawget L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_rawgeti (lua_State* L, int idx, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_rawgeti)(L,idx,n);
 printf("%s:%d [%s] lua_rawgeti L=%p idx=%d n=%d\n",
	_FILE,_LINE,_FUNC,L,idx,n);
}

void Lua_createtable (lua_State* L, int narr, int nrec,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_createtable)(L,narr,nrec);
 printf("%s:%d [%s] lua_createtable L=%p narr=%d nrec=%d\n",
	_FILE,_LINE,_FUNC,L,narr,nrec);
}

void* Lua_newuserdata (lua_State* L, size_t sz,
	const char* _FILE, int _LINE, const char* _FUNC) {
 void* rc = (lua_newuserdata)(L,sz);
 printf("%s:%d [%s] lua_newuserdata L=%p sz=%u -> %p\n",
	_FILE,_LINE,_FUNC,L,sz,rc);
 return rc;
}

int Lua_getmetatable (lua_State* L, int objindex,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_getmetatable)(L,objindex);
 printf("%s:%d [%s] lua_getmetatable L=%p objindex=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,objindex,rc);
 return rc;
}

void Lua_getfenv (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_getfenv)(L,idx);
 printf("%s:%d [%s] lua_getfenv L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_settable (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_settable)(L,idx);
 printf("%s:%d [%s] lua_settable L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_setfield (lua_State* L, int idx, const char* k,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_setfield)(L,idx,k);
 printf("%s:%d [%s] lua_setfield L=%p idx=%d k=\"%s\"\n",
	_FILE,_LINE,_FUNC,L,idx,k);
}

void Lua_rawset (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_rawset)(L,idx);
 printf("%s:%d [%s] lua_rawset L=%p idx=%d\n",
	_FILE,_LINE,_FUNC,L,idx);
}

void Lua_rawseti (lua_State* L, int idx, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_rawseti)(L,idx,n);
 printf("%s:%d [%s] lua_rawseti L=%p idx=%d n=%d\n",
	_FILE,_LINE,_FUNC,L,idx,n);
}

int Lua_setmetatable (lua_State* L, int objindex,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_setmetatable)(L,objindex);
 printf("%s:%d [%s] lua_setmetatable L=%p objindex=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,objindex,rc);
 return rc;
}

int Lua_setfenv (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_setfenv)(L,idx);
 printf("%s:%d [%s] lua_setfenv L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

void Lua_call (lua_State* L, int nargs, int nresults,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_call)(L,nargs,nresults);
 printf("%s:%d [%s] lua_call L=%p nargs=%d nresults=%d\n",
	_FILE,_LINE,_FUNC,L,nargs,nresults);
}

int Lua_pcall (lua_State* L, int nargs, int nresults, int errfunc,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_pcall)(L,nargs,nresults,errfunc);
 printf("%s:%d [%s] lua_pcall L=%p nargs=%d nresults=%d errfunc=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,nargs,nresults,errfunc,rc);
 return rc;
}

int Lua_cpcall (lua_State* L, lua_CFunction func, void* ud,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_cpcall)(L,func,ud);
 printf("%s:%d [%s] lua_cpcall L=%p func=%p ud=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,func,ud,rc);
 return rc;
}

int Lua_load (lua_State* L, lua_Reader reader, void* dt,
 const char* chunkname,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_load)(L,reader,dt,chunkname);
 printf("%s:%d [%s] lua_load L=%p reader=%p dt=%p chunkname=\"%s\" -> %d\n",
	_FILE,_LINE,_FUNC,L,reader,dt,chunkname,rc);
 return rc;
}

int Lua_dump (lua_State* L, lua_Writer writer, void* data,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_dump)(L,writer,data);
 printf("%s:%d [%s] lua_dump L=%p writer=%p data=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,writer,data,rc);
 return rc;
}

int Lua_yield (lua_State* L, int nresults,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_yield)(L,nresults);
 printf("%s:%d [%s] lua_yield L=%p nresults=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,nresults,rc);
 return rc;
}

int Lua_resume (lua_State* L, int narg,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_resume)(L,narg);
 printf("%s:%d [%s] lua_resume L=%p narg=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,narg,rc);
 return rc;
}

int Lua_status (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_status)(L);
 printf("%s:%d [%s] lua_status L=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}

int Lua_gc (lua_State* L, int what, int data,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_gc)(L,what,data);
 printf("%s:%d [%s] lua_gc L=%p what=%d data=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,what,data,rc);
 return rc;
}

int Lua_error (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_error)(L);
 printf("%s:%d [%s] lua_error L=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}

int Lua_next (lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_next)(L,idx);
 printf("%s:%d [%s] lua_next L=%p idx=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,idx,rc);
 return rc;
}

void Lua_concat (lua_State* L, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_concat)(L,n);
 printf("%s:%d [%s] lua_concat L=%p n=%d\n",
	_FILE,_LINE,_FUNC,L,n);
}

lua_Alloc Lua_getallocf (lua_State* L, void* *ud,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_Alloc rc = (lua_getallocf)(L,ud);
 printf("%s:%d [%s] lua_getallocf L=%p ud=%p -> %p\n",
	_FILE,_LINE,_FUNC,L,ud,rc);
 return rc;
}

void Lua_setallocf (lua_State* L, lua_Alloc f, void* ud,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_setallocf)(L,f,ud);
 printf("%s:%d [%s] lua_setallocf L=%p f=%p ud=%p\n",
	_FILE,_LINE,_FUNC,L,f,ud);
}

void Lua_setlevel (lua_State* from, lua_State* to,
	const char* _FILE, int _LINE, const char* _FUNC) {
 (lua_setlevel)(from,to);
 printf("%s:%d [%s] lua_setlevel from=%p to=%p\n",
	_FILE,_LINE,_FUNC,from,to);
}

int Lua_getstack (lua_State* L, int level, lua_Debug* ar,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_getstack)(L,level,ar);
 printf("%s:%d [%s] lua_getstack L=%p level=%d ar=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,level,ar,rc);
 return rc;
}

int Lua_getinfo (lua_State* L, const char* what, lua_Debug* ar,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_getinfo)(L,what,ar);
 printf("%s:%d [%s] lua_getinfo L=%p what=\"%s\" ar=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,what,ar,rc);
 return rc;
}

const char* Lua_getlocal (lua_State* L, const lua_Debug* ar, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 const char* rc = (lua_getlocal)(L,ar,n);
 printf("%s:%d [%s] lua_getlocal L=%p ar=%p n=%d -> \"%s\"\n",
	_FILE,_LINE,_FUNC,L,ar,n,rc);
 return rc;
}

const char* Lua_setlocal (lua_State* L, const lua_Debug* ar, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 const char* rc = (lua_setlocal)(L,ar,n);
 printf("%s:%d [%s] lua_setlocal L=%p ar=%p n=%d -> \"%s\"\n",
	_FILE,_LINE,_FUNC,L,ar,n,rc);
 return rc;
}

const char* Lua_getupvalue (lua_State* L, int funcindex, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 const char* rc = (lua_getupvalue)(L,funcindex,n);
 printf("%s:%d [%s] lua_getupvalue L=%p funcindex=%d n=%d -> \"%s\"\n",
	_FILE,_LINE,_FUNC,L,funcindex,n,rc);
 return rc;
}

const char* Lua_setupvalue (lua_State* L, int funcindex, int n,
	const char* _FILE, int _LINE, const char* _FUNC) {
 const char* rc = (lua_setupvalue)(L,funcindex,n);
 printf("%s:%d [%s] lua_setupvalue L=%p funcindex=%d n=%d -> \"%s\"\n",
	_FILE,_LINE,_FUNC,L,funcindex,n,rc);
 return rc;
}

int Lua_sethook (lua_State* L, lua_Hook func, int mask, int count,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_sethook)(L,func,mask,count);
 printf("%s:%d [%s] lua_sethook L=%p func=%p mask=%d count=%d -> %d\n",
	_FILE,_LINE,_FUNC,L,func,mask,count,rc);
 return rc;
}

lua_Hook Lua_gethook (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 lua_Hook rc = (lua_gethook)(L);
 printf("%s:%d [%s] lua_gethook L=%p -> %p\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}

int Lua_gethookmask (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_gethookmask)(L);
 printf("%s:%d [%s] lua_gethookmask L=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}

int Lua_gethookcount (lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC) {
 int rc = (lua_gethookcount)(L);
 printf("%s:%d [%s] lua_gethookcount L=%p -> %d\n",
	_FILE,_LINE,_FUNC,L,rc);
 return rc;
}
