/* ctrace.h -- automatically extracted from lua.h (5.1) */

#ifdef __LCC__
#define __FUNCTION__ __func__
#else
#ifndef __GNUC__
#define __FUNCTION__ "-"
#endif
#endif

#include "lua.h"
#include "lauxlib.h"

#if LUA_VERSION_NUM != 501
#error this ctrace.h is for Lua 5.1
#endif

lua_State* Lua_newstate(lua_Alloc f, void* ud,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_newstate(f,ud) \
	Lua_newstate(f,ud,__FILE__,__LINE__,__FUNCTION__)

void Lua_close(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_close(L) \
	Lua_close(L,__FILE__,__LINE__,__FUNCTION__)

lua_State* Lua_newthread(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_newthread(L) \
	Lua_newthread(L,__FILE__,__LINE__,__FUNCTION__)

lua_CFunction Lua_atpanic(lua_State* L, lua_CFunction panicf,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_atpanic(L,panicf) \
	Lua_atpanic(L,panicf,__FILE__,__LINE__,__FUNCTION__)

int Lua_gettop(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_gettop(L) \
	Lua_gettop(L,__FILE__,__LINE__,__FUNCTION__)

void Lua_settop(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_settop(L,idx) \
	Lua_settop(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushvalue(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushvalue(L,idx) \
	Lua_pushvalue(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_remove(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_remove(L,idx) \
	Lua_remove(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_insert(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_insert(L,idx) \
	Lua_insert(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_replace(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_replace(L,idx) \
	Lua_replace(L,idx,__FILE__,__LINE__,__FUNCTION__)

int Lua_checkstack(lua_State* L, int sz,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_checkstack(L,sz) \
	Lua_checkstack(L,sz,__FILE__,__LINE__,__FUNCTION__)

void Lua_xmove(lua_State* from, lua_State* to, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_xmove(from,to,n) \
	Lua_xmove(from,to,n,__FILE__,__LINE__,__FUNCTION__)

int Lua_isnumber(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_isnumber(L,idx) \
	Lua_isnumber(L,idx,__FILE__,__LINE__,__FUNCTION__)

int Lua_isstring(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_isstring(L,idx) \
	Lua_isstring(L,idx,__FILE__,__LINE__,__FUNCTION__)

int Lua_iscfunction(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_iscfunction(L,idx) \
	Lua_iscfunction(L,idx,__FILE__,__LINE__,__FUNCTION__)

int Lua_isuserdata(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_isuserdata(L,idx) \
	Lua_isuserdata(L,idx,__FILE__,__LINE__,__FUNCTION__)

int Lua_type(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_type(L,idx) \
	Lua_type(L,idx,__FILE__,__LINE__,__FUNCTION__)

const char* Lua_typename(lua_State* L, int tp,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_typename(L,tp) \
	Lua_typename(L,tp,__FILE__,__LINE__,__FUNCTION__)

int Lua_equal(lua_State* L, int idx1, int idx2,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_equal(L,idx1,idx2) \
	Lua_equal(L,idx1,idx2,__FILE__,__LINE__,__FUNCTION__)

int Lua_rawequal(lua_State* L, int idx1, int idx2,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_rawequal(L,idx1,idx2) \
	Lua_rawequal(L,idx1,idx2,__FILE__,__LINE__,__FUNCTION__)

int Lua_lessthan(lua_State* L, int idx1, int idx2,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_lessthan(L,idx1,idx2) \
	Lua_lessthan(L,idx1,idx2,__FILE__,__LINE__,__FUNCTION__)

lua_Number Lua_tonumber(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_tonumber(L,idx) \
	Lua_tonumber(L,idx,__FILE__,__LINE__,__FUNCTION__)

lua_Integer Lua_tointeger(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_tointeger(L,idx) \
	Lua_tointeger(L,idx,__FILE__,__LINE__,__FUNCTION__)

int Lua_toboolean(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_toboolean(L,idx) \
	Lua_toboolean(L,idx,__FILE__,__LINE__,__FUNCTION__)

const char* Lua_tolstring(lua_State* L, int idx, size_t* len,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_tolstring(L,idx,len) \
	Lua_tolstring(L,idx,len,__FILE__,__LINE__,__FUNCTION__)

size_t Lua_objlen(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_objlen(L,idx) \
	Lua_objlen(L,idx,__FILE__,__LINE__,__FUNCTION__)

lua_CFunction Lua_tocfunction(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_tocfunction(L,idx) \
	Lua_tocfunction(L,idx,__FILE__,__LINE__,__FUNCTION__)

void* Lua_touserdata(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_touserdata(L,idx) \
	Lua_touserdata(L,idx,__FILE__,__LINE__,__FUNCTION__)

lua_State* Lua_tothread(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_tothread(L,idx) \
	Lua_tothread(L,idx,__FILE__,__LINE__,__FUNCTION__)

const void* Lua_topointer(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_topointer(L,idx) \
	Lua_topointer(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushnil(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushnil(L) \
	Lua_pushnil(L,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushnumber(lua_State* L, lua_Number n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushnumber(L,n) \
	Lua_pushnumber(L,n,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushinteger(lua_State* L, lua_Integer n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushinteger(L,n) \
	Lua_pushinteger(L,n,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushlstring(lua_State* L, const char* s, size_t l,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushlstring(L,s,l) \
	Lua_pushlstring(L,s,l,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushstring(lua_State* L, const char* s,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushstring(L,s) \
	Lua_pushstring(L,s,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushcclosure(lua_State* L, lua_CFunction fn, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushcclosure(L,fn,n) \
	Lua_pushcclosure(L,fn,n,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushboolean(lua_State* L, int b,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushboolean(L,b) \
	Lua_pushboolean(L,b,__FILE__,__LINE__,__FUNCTION__)

void Lua_pushlightuserdata(lua_State* L, void* p,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushlightuserdata(L,p) \
	Lua_pushlightuserdata(L,p,__FILE__,__LINE__,__FUNCTION__)

int Lua_pushthread(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pushthread(L) \
	Lua_pushthread(L,__FILE__,__LINE__,__FUNCTION__)

void Lua_gettable(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_gettable(L,idx) \
	Lua_gettable(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_getfield(lua_State* L, int idx, const char* k,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getfield(L,idx,k) \
	Lua_getfield(L,idx,k,__FILE__,__LINE__,__FUNCTION__)

void Lua_rawget(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_rawget(L,idx) \
	Lua_rawget(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_rawgeti(lua_State* L, int idx, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_rawgeti(L,idx,n) \
	Lua_rawgeti(L,idx,n,__FILE__,__LINE__,__FUNCTION__)

void Lua_createtable(lua_State* L, int narr, int nrec,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_createtable(L,narr,nrec) \
	Lua_createtable(L,narr,nrec,__FILE__,__LINE__,__FUNCTION__)

void* Lua_newuserdata(lua_State* L, size_t sz,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_newuserdata(L,sz) \
	Lua_newuserdata(L,sz,__FILE__,__LINE__,__FUNCTION__)

int Lua_getmetatable(lua_State* L, int objindex,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getmetatable(L,objindex) \
	Lua_getmetatable(L,objindex,__FILE__,__LINE__,__FUNCTION__)

void Lua_getfenv(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getfenv(L,idx) \
	Lua_getfenv(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_settable(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_settable(L,idx) \
	Lua_settable(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_setfield(lua_State* L, int idx, const char* k,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_setfield(L,idx,k) \
	Lua_setfield(L,idx,k,__FILE__,__LINE__,__FUNCTION__)

void Lua_rawset(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_rawset(L,idx) \
	Lua_rawset(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_rawseti(lua_State* L, int idx, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_rawseti(L,idx,n) \
	Lua_rawseti(L,idx,n,__FILE__,__LINE__,__FUNCTION__)

int Lua_setmetatable(lua_State* L, int objindex,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_setmetatable(L,objindex) \
	Lua_setmetatable(L,objindex,__FILE__,__LINE__,__FUNCTION__)

int Lua_setfenv(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_setfenv(L,idx) \
	Lua_setfenv(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_call(lua_State* L, int nargs, int nresults,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_call(L,nargs,nresults) \
	Lua_call(L,nargs,nresults,__FILE__,__LINE__,__FUNCTION__)

int Lua_pcall(lua_State* L, int nargs, int nresults, int errfunc,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_pcall(L,nargs,nresults,errfunc) \
	Lua_pcall(L,nargs,nresults,errfunc,__FILE__,__LINE__,__FUNCTION__)

int Lua_cpcall(lua_State* L, lua_CFunction func, void* ud,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_cpcall(L,func,ud) \
	Lua_cpcall(L,func,ud,__FILE__,__LINE__,__FUNCTION__)

int Lua_load(lua_State* L, lua_Reader reader, void* dt,
 const char* chunkname,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_load(L,reader,dt,chunkname) \
	Lua_load(L,reader,dt,chunkname,__FILE__,__LINE__,__FUNCTION__)

int Lua_dump(lua_State* L, lua_Writer writer, void* data,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_dump(L,writer,data) \
	Lua_dump(L,writer,data,__FILE__,__LINE__,__FUNCTION__)

int Lua_yield(lua_State* L, int nresults,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_yield(L,nresults) \
	Lua_yield(L,nresults,__FILE__,__LINE__,__FUNCTION__)

int Lua_resume(lua_State* L, int narg,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_resume(L,narg) \
	Lua_resume(L,narg,__FILE__,__LINE__,__FUNCTION__)

int Lua_status(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_status(L) \
	Lua_status(L,__FILE__,__LINE__,__FUNCTION__)

int Lua_gc(lua_State* L, int what, int data,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_gc(L,what,data) \
	Lua_gc(L,what,data,__FILE__,__LINE__,__FUNCTION__)

int Lua_error(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_error(L) \
	Lua_error(L,__FILE__,__LINE__,__FUNCTION__)

int Lua_next(lua_State* L, int idx,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_next(L,idx) \
	Lua_next(L,idx,__FILE__,__LINE__,__FUNCTION__)

void Lua_concat(lua_State* L, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_concat(L,n) \
	Lua_concat(L,n,__FILE__,__LINE__,__FUNCTION__)

lua_Alloc Lua_getallocf(lua_State* L, void* *ud,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getallocf(L,ud) \
	Lua_getallocf(L,ud,__FILE__,__LINE__,__FUNCTION__)

void Lua_setallocf(lua_State* L, lua_Alloc f, void* ud,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_setallocf(L,f,ud) \
	Lua_setallocf(L,f,ud,__FILE__,__LINE__,__FUNCTION__)

void Lua_setlevel(lua_State* from, lua_State* to,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_setlevel(from,to) \
	Lua_setlevel(from,to,__FILE__,__LINE__,__FUNCTION__)

int Lua_getstack(lua_State* L, int level, lua_Debug* ar,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getstack(L,level,ar) \
	Lua_getstack(L,level,ar,__FILE__,__LINE__,__FUNCTION__)

int Lua_getinfo(lua_State* L, const char* what, lua_Debug* ar,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getinfo(L,what,ar) \
	Lua_getinfo(L,what,ar,__FILE__,__LINE__,__FUNCTION__)

const char* Lua_getlocal(lua_State* L, const lua_Debug* ar, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getlocal(L,ar,n) \
	Lua_getlocal(L,ar,n,__FILE__,__LINE__,__FUNCTION__)

const char* Lua_setlocal(lua_State* L, const lua_Debug* ar, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_setlocal(L,ar,n) \
	Lua_setlocal(L,ar,n,__FILE__,__LINE__,__FUNCTION__)

const char* Lua_getupvalue(lua_State* L, int funcindex, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_getupvalue(L,funcindex,n) \
	Lua_getupvalue(L,funcindex,n,__FILE__,__LINE__,__FUNCTION__)

const char* Lua_setupvalue(lua_State* L, int funcindex, int n,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_setupvalue(L,funcindex,n) \
	Lua_setupvalue(L,funcindex,n,__FILE__,__LINE__,__FUNCTION__)

int Lua_sethook(lua_State* L, lua_Hook func, int mask, int count,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_sethook(L,func,mask,count) \
	Lua_sethook(L,func,mask,count,__FILE__,__LINE__,__FUNCTION__)

lua_Hook Lua_gethook(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_gethook(L) \
	Lua_gethook(L,__FILE__,__LINE__,__FUNCTION__)

int Lua_gethookmask(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_gethookmask(L) \
	Lua_gethookmask(L,__FILE__,__LINE__,__FUNCTION__)

int Lua_gethookcount(lua_State* L,
	const char* _FILE, int _LINE, const char* _FUNC);

#define	lua_gethookcount(L) \
	Lua_gethookcount(L,__FILE__,__LINE__,__FUNCTION__)
